local on = vim.api.nvim_create_autocmd

on({ "TermOpen", "TermEnter" }, {
	callback = function()
		vim.opt_local.signcolumn = "no"
	end,
})

on({ "BufNewFile", "BufRead" }, {
	pattern = { "*.txt", "*.md" },
	callback = function()
		vim.opt_local.wrap = true
		vim.opt_local.signcolumn = "no"
	end,
})

on({ "VimEnter" }, {
	callback = function()
		-- Switch to root directory of the project
		local root_patterns = { ".git", "go.mod", "init.lua" }
		local root_dir = vim.fs.dirname(vim.fs.find(root_patterns, { upward = true })[1])

		if root_dir then
			vim.api.nvim_set_current_dir(root_dir)
		end

		-- Open file explorer if we have enough space
		local files = require("nvim-tree.api")
		local width = vim.go.columns

		if width > 120 then
			files.tree.toggle({ focus = false })
		end
	end,
})
